/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-14 15:32:06 UTC)
 * on 2013-08-19 at 20:39:54 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.doubleclickbidmanager.model;

/**
 * List queries response.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the DoubleClick Bid Manager API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ListQueriesResponse extends com.google.api.client.json.GenericJson {

  /**
   * The kind, fixed to "doubleclickbidmanager#listQueriesResponse".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Retrieved queries.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Query> queries;

  static {
    // hack to force ProGuard to consider Query used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Query.class);
  }

  /**
   * The kind, fixed to "doubleclickbidmanager#listQueriesResponse".
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind, fixed to "doubleclickbidmanager#listQueriesResponse".
   * @param kind kind or {@code null} for none
   */
  public ListQueriesResponse setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Retrieved queries.
   * @return value or {@code null} for none
   */
  public java.util.List<Query> getQueries() {
    return queries;
  }

  /**
   * Retrieved queries.
   * @param queries queries or {@code null} for none
   */
  public ListQueriesResponse setQueries(java.util.List<Query> queries) {
    this.queries = queries;
    return this;
  }

  @Override
  public ListQueriesResponse set(String fieldName, Object value) {
    return (ListQueriesResponse) super.set(fieldName, value);
  }

  @Override
  public ListQueriesResponse clone() {
    return (ListQueriesResponse) super.clone();
  }

}
